//regi.cpp main program
//Coded by Mats Karlsson
//ets97mka@student.hk-r.se
//nevcx@fukt.hk-r.se
#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "user.h"

struct tm *newtime;
time_t aclock; 

int numberOfusers(user *temp);
void printList(user *temp);
void printHelp();
int  scanOption(char **, char *); 
user *readPasswd(char File_name[], char Ignore_file_name[], user *first, int verbose);
int ignore(char username[], char Ignore_file_name[]);
void makeUserHtml(user *first, char *Html_file_name, char *email_Domain, int finger, char *logo_pic, int);
user *sortList(user *first);
user *sortLogins(user *first);
char *readLast(user *first,  char *Last_file_name);
user *findUser(char user[], user *first);
void makeLoginsHtml(user *first, char *File_name, char *hostName, char *wtmpDate);

int main(int argc, char *argv[])
{
	user *first = NULL;
	user *temp = first;
	char File_name[255] = "passwd.txt";
	char Ignore_file_name[255] = "ignore.txt";
	char Last_file_name[255] = "last.txt";
	char Html_file_name[255] = "medlemmar.html";
	char Html_file_name_logins[255] = "logins.html";
	char email_Domain[255] = "fukt.hk-r.se"; 
	char logo_pic[255] = "image/medlemmar.gif";
	int nrOfUsers = 0;
	int finger = 0;
	int verbose = 0;
	int optionPosition;	
	char hostName[20];
        char *wtmpDate;

	if(argc == 1 )
        {
                printHelp();
                return 0;
        }
	if( scanOption(argv, "--help") )
        {
                printHelp();
                return 0;
        }
	if( optionPosition = scanOption(argv, "-p" ) )		// passwd
                strcpy(File_name, argv[++optionPosition]);
        if( optionPosition = scanOption(argv, "-i" ) )		// ignore
                strcpy(Ignore_file_name, argv[++optionPosition]);
	if( optionPosition = scanOption(argv, "-l" ) )		// last
                strcpy(Last_file_name, argv[++optionPosition]); 
	if( optionPosition = scanOption(argv, "-u" ) )		// user-html
                strcpy(Html_file_name, argv[++optionPosition]);
	if( optionPosition = scanOption(argv, "-w") )		// logins-html
		strcpy(Html_file_name_logins, argv[++optionPosition]);
	if( optionPosition = scanOption(argv, "-e" ) )		// email
                strcpy(email_Domain, argv[++optionPosition]); 
	if( optionPosition = scanOption(argv, "-b" ) )		// logotype
                strcpy(logo_pic, argv[++optionPosition]);
	if( optionPosition = scanOption(argv, "-f" ) )		// finger
                finger = 1; 
	if( optionPosition = scanOption(argv, "-v" ) )		// verbose
                verbose = 1;
	if( optionPosition = scanOption(argv, "-h" ) )		// hostname
                strcpy(hostName, argv[++optionPosition]);
        else
                strcpy(hostName, "on host"); 

	first = readPasswd(File_name, Ignore_file_name, first, verbose); 	// make linked list
	if( scanOption(argv, "-l") )						// use last
		wtmpDate = readLast(first, Last_file_name); 
	
	if( optionPosition = scanOption(argv, "-u" ) && first != NULL )		// make user html 
	{
		first = sortList(first); 	
		nrOfUsers = numberOfusers(first);
		makeUserHtml(first, Html_file_name, email_Domain, finger, logo_pic, nrOfUsers);
	}
	if( scanOption(argv, "-w") && scanOption(argv, "-l") && first != NULL )	// make logins html
	{
		first = sortLogins(first);
		makeLoginsHtml(first, Html_file_name_logins, hostName, wtmpDate);
	}
	if( optionPosition = scanOption(argv, "-r" ) && scanOption(argv, "-p") )// list-users 
	{
		first = sortList(first);
		printList(first);
	}
	first->~user();
	return 0;
}

int numberOfusers(user *temp)
{
        int nrOfUsers = 0;
	int flag = 0;
        while(flag == 0)
        {
                if (temp->next == NULL)
                        flag = 1;
                nrOfUsers++; 
                temp = temp->next;
        }
return nrOfUsers;
}

void printList(user *temp)
{
       	int flag = 0;
	while(flag == 0)
       	{
       		if (temp->next == NULL)
       			flag = 1;
       		temp->printuser();
       		temp = temp->next;
      	}
}

void printHelp()
{
        cout << "MLIST v1.3 - Generate user-lists on Unix systems ";
        cout << "\nMats Karlsson (nevcx@fukt.hk-r.se)";
        //cout << "\n\nmlist [-p passwd] [-i ignore] [-h html] [-d email] [-f] [-l logo] [-r] [-v]\n" ;
        cout << "\n\nmlist [ -p file -i file -l file -u file -w file -e domain -f -h name -b file -r -v\n";
	cout << "\n -p\t passwd-file.     Default: passwd.txt";
        cout << "\n -i\t ignore-file.     Default: ignore.txt";
	cout << "\n -l\t last-file.";
        cout << "\n -u\t user html-file.  Default: medlemmar.html";
        cout << "\n -w\t logins html-list.";
	cout << "\n -e\t E-mail domain.   Default: fukt.hk-r.se";
        cout << "\n -f\t finger.          Default: Off";
        cout << "\n -h\t hostname";
	cout << "\n -b\t logotype.        Default: image/medlemmar.gif";
	cout << "\n -r\t list sorted userlist"; 
	cout << "\n -v\t verbose mode";
        cout << "\n --help\t view help";
        cout << "\n" << flush;

	cout << "\nExamples: \n./mlist -p /etc/passwd -i ignore -h ~/html/medlemmar.html -d fukt.hk-r.se -f";
	cout << "\n./mlist -p /etc/passwd -i ignore -r > ~/userlist.txt";
	cout << "\n./mlist -l /image/users.gif";
	cout << "\n./mlist -v | less";
	cout << "\n\n" << flush; 
} 

int  scanOption(char *argv[], char option[])
{
        for(int c = 0; argv[c] != NULL; c++)
        {
                if( ! strcmp(argv[c], option) )
                        return c;
        }
        return 0;
} 

user *readPasswd(char File_name[], char Ignore_file_name[], user *first, int verbose)
{
	char username[20];
	char firstname[20];
	char lastname[20];
	char passwdLine[256];
	int pos = 0;
	int c = 0;
	int n = 0;

	fstream inFile(File_name, ios::in );
	if ( ! inFile)
		{
				cout << "Sorry, can't open " << File_name << " for input.\n";
			exit(1);
	}
		else
	{
		while( ! (inFile.getline(passwdLine , 255)).eof() )
		{
			for(pos = 0; passwdLine[pos] != ':' 
			&& passwdLine[pos] != '\0' ; pos++)
				username[pos] = passwdLine[pos];
			username[pos] = '\0';
			pos++;
			while(passwdLine[pos] != ':' && passwdLine[pos] != '\0' )
				pos++; pos++;
			while(passwdLine[pos] != ':' && passwdLine[pos] != '\0' )
				pos++; pos++;
			while(passwdLine[pos] != ':' && passwdLine[pos] != '\0' )
				pos++; pos++;
			for(c = 0; passwdLine[pos] != ' ' 
			&& passwdLine[pos] != ':' 
			&& passwdLine[pos] != '\0' ; pos++, c++)
				firstname[c] = passwdLine[pos];
			firstname[c] = '\0';
			if(passwdLine[pos] == ' ')
                                        pos++;
			for(c = 0; passwdLine[pos] != ':' 
			&& passwdLine[pos] != '\0' ; pos++, c++)
			{
				lastname[c] = passwdLine[pos];
			}
			lastname[c] = '\0';
			if( !(ignore(username, Ignore_file_name)) )
			{
				first = new user(first, username, firstname, lastname);
				n++;
				if(verbose)
				{
					cout << "+ Include: " << n << "\t";
					first->printuser();
					
				}
			}
			else
				if(verbose)
					cout << "- Exclude:  \t" << username << "\n";
		}
	inFile.close();
	}
	if(verbose)
		cout << "\n" << n << " users." << "\n";
	return first;
}

int ignore(char username[], char Ignore_file_name[])
{
	char ignoreLine[256];
	fstream inFile2(Ignore_file_name, ios::in );
	if ( ! inFile2)
		{
			cout << "Sorry, can't open " << Ignore_file_name << " for reading.\n" << flush;
			inFile2.close();
			return 0;
		}
		else
		while( ! (inFile2.getline(ignoreLine , 255)).eof() )
		{
			if(strcmp(ignoreLine, username) == 0)
			{
				return 1;
			}
		}
		inFile2.close();

	return 0;
}

void makeUserHtml(user *first, char *Html_file_name, char *email_Domain, int finger, char *logo_pic, int nrOfUsers)
{
	int flag = 0;
	user *temp = first;
	fstream outFile(Html_file_name, ios::trunc | ios::out);

		  if ( ! outFile)
		  {
					 cout << "Sorry, can't open " << Html_file_name << " for output.\n";
		  }
		  else
		  {
		outFile << "<HTML>\n<HEAD>\n<TITLE>Medlemmar i FUKT</TITLE>\n</HEAD>";
		outFile << "\n<BODY TEXT=\"#000000\" BGCOLOR=\"#FFFFFF\" LINK=\"#0000FF\" ";
		outFile << "VLINK=\"#551A8B\" ALINK=\"#551A8B\">";
		outFile << "\n<CENTER><P><BASE TARGET=\"_top\"></P></CENTER>";
		outFile << "\n<CENTER><P><IMG SRC=\"";
		outFile << logo_pic ;
		outFile << "\"LOWSRC=\"image/medlemmar.gif\" HEIGHT=39 WIDTH=225><BR>";
		outFile << "\n<BR><BR></P></CENTER>";
		outFile << "<CENTER><TABLE BORDER=1 CELLPADDING=0>";
		outFile << "\n<TR> ";
		outFile << "\n<TH ALIGN=CENTER COLSPAN=4 BGCOLOR=Silver> <B>Number of users = ";
		outFile << nrOfUsers << "</B></TH>";
		outFile << "\n<TR> ";
		outFile << "\n<TD ALIGN=LEFT BGCOLOR=#009CBD>";
		outFile << "\n<P><B><U>Name</U></B></P>";
		outFile << "\n</TD>";
		outFile << "\n<TD ALIGN=LEFT BGCOLOR=#009CBD>";
		outFile << "\n<P><B><U>Alias </U></B></P>";
		outFile << "\n</TD>";
		if(finger)
		{
			outFile << "\n<TD BGCOLOR=#009CBD>";
			outFile << "\n<P><B><U>Finger</U></B></P>";
			outFile << "\n</TD>";
		}
		outFile << "\n<TD ALIGN=LEFT BGCOLOR=#009CBD>";
		outFile << "\n<P><B><U>Email</U></B></P>";
		outFile << "\n</TD></TR>";

	while(flag == 0)
	{
		if (temp->next == NULL)
			flag = 1;
		outFile << "\n<TR><TD bgcolor=#FFFEE1><B>" << temp->getlastname() << ", ";
		outFile << temp->getfirstname() << "</TD>";
		outFile << "\n<TD bgcolor=Silver><B><A HREF=\"http://www.fukt.hk-r.se/~" << temp->getusername();
		outFile << "/\">" << temp->getusername() << "</A></TD>";
		if(finger)
		{
			outFile << "\n<TD bgcolor=#D8FDCE><B><A HREF=\"http://www.fukt.hk-r.se/cgi-bin/fingeruser.cgi?";
			outFile << temp->getusername() << "\" target=\"main\"><IMG ";
			outFile << "SRC=\"image/finger.gif\" BORDER=0 HEIGHT=26 WIDTH=24>";
			outFile << "</A></TD>";
		}
		outFile << "\n<TD bgcolor=Silver><B><A HREF=\"mailto:" << temp->getusername() ;
		outFile << "@" << email_Domain << "\">";
		outFile << temp->getusername() << "@" << email_Domain << "</A></TD></TR>";
		temp = temp->next;
	}
	outFile << "\n<TR> ";
        outFile << "\n<TD ALIGN=CENTER COLSPAN=4 BGCOLOR=Silver> <B>";
	outFile << "Generated by mlist : ";
	outFile << "<A HREF=ftp://ftp.fukt.hk-r.se/pub/Linux/mlist/>";
	outFile << "ftp://ftp.fukt.hk-r.se/pub/Linux/mlist/</A></B><TD></TR>";
	outFile << "</TABLE></CENTER>";
	outFile << "<CENTER><P>";
	outFile << "<HR WIDTH=\"80%\"><FONT SIZE=-1>&copy; ";
	outFile << "1997 FUKT. Alla r&auml;ttigheter reserverade.<BR>";
	outFile << "Vid problem kontakta <A HREF=\"mailto:webmaster@fukt.hk-r.se\">";
	outFile << "webmaster@fukt.hk-r.se</A></FONT></P></CENTER>";

	outFile << "\n</BODY>";
	outFile << "\n</HTML>";
	}
}

user *sortList(user *first)
{
	user *sortedList = NULL;
	user *lastSorted  = sortedList;
	user *beforeBest = first;
	user *temp = first;
	user *loop = first;
	user *best = first;
	int n = 0;

	while(first != NULL)
	{
		loop = first;
		while(loop != NULL)
		{
			int comp = strcmp(best->getlastname(), loop->getlastname()); 
			if(comp <= 0)
			{
				if(comp == 0)
				{
					if(strcmp(best->getfirstname(), loop->getfirstname()) <= 0)
						best = loop;
				}
				else
					best = loop;
			}
			loop = loop->next;
		}
		temp = first;
		while(temp->next != NULL)
		{
			if(temp->next == best)
				beforeBest = temp;
			temp = temp->next;
		}
		lastSorted = sortedList;
		sortedList = best; //1
		if(best != first && beforeBest != best)
		{
			beforeBest->next = best->next; //2
		}
		if(best == first && beforeBest != best)
		{
			first = first->next;
		}
		if(first == best && beforeBest == best)
		{
			first = first->next;
		}
		best->next = lastSorted;
		beforeBest = first;
		temp = first;
		loop = first;
		best = first;
		n++;
	}
return sortedList;
}

char *readLast(user *first,  char *Last_file_name)
{
        char lastLine[256];
        char time[10];
        char *pp;
        int timeInt;
        char userItem[20];
        char *wtmpDate = new char[80];

        fstream inFile2(Last_file_name, ios::in );

        if ( ! inFile2)
        {
                cout << "Sorry, can't open " << Last_file_name << " for input.\n";
                inFile2.close(); 
		return NULL;
        }
        else
        {

                while( ! (inFile2.getline(lastLine , 255)).eof() )
                {
                        pp = index( lastLine, int('(') );
                        if(pp != NULL)
                        {
                                int c = 0;
                                while(lastLine[c] != ' ')
                                {
                                        userItem[c] = lastLine[c];
                                        c++;
                                }
                                userItem[c]='\0';
                                user *userP = findUser(userItem, first);
                        	if( userP != NULL)
				{        
			        	if(pp[2] == '+')
                                        {
                                                userP->putDay((int(pp[1])-48));
                                                time[0] = pp[3];
                                                time[1] = pp[4];
                                                time[2] = pp[5];
                                                time[3] = pp[6];
                                                time[4] = pp[7];  
                                        }
                                        else
                                        {
                                                time[0] = pp[1];
                                                time[1] = pp[2];
                                                time[2] = pp[3];
                                                time[3] = pp[4];
                                                time[4] = pp[5];
                                        }
                                }
				time[5]='\0';
                                timeInt = userP->char2int(time);
                                userP = findUser(userItem, first);
                                if( userP != NULL )
					userP->putTime(timeInt);
                        }
                        else
                                if( ! strncmp( "wtmp", lastLine, 4 ) )
                                        strcpy (wtmpDate , lastLine);
                }
                inFile2.close();
        }                     
        return wtmpDate;
}                                                                           

user *findUser(char user[], user *first)
{
        while(first != NULL)
        {
                if( !strcmp( first->getusername() , user ) )
                        return first;
                else
                        first = first->next;
        }
        return first;
} 

void makeLoginsHtml(user *first, char *File_name, char *hostName, char *wtmpDate)
{
        user *temp = first;
        int position = 0;
	time( &aclock );                 /* Get time in seconds */
        newtime = localtime( &aclock );
        fstream outFile(File_name, ios::trunc | ios::out);

        if ( ! outFile)
        {
                cout << "Sorry, can't open " << File_name << " for output.\n";
        }
        else
        {
                outFile << "<html>\n<HEAD><TITLE>TOP LOGINS "<< hostName << "</TITLE></HEAD>\n<BODY BGCOLOR= \"#FFFFFF\"";
                outFile << " TEXT=\"#000000\" LINK=\"#0000FF\" VLINK=\"#551A8B\">";
                outFile << "<BASE TARGET=_top>\n";
                outFile << "<DD><TABLE BORDER=1>";
                outFile << "<TR><TD ALIGN=center VALIGN=top COLSPAN=9 BORDER=1 BGCOLOR=#009CBD>";
                outFile << "<BR><H1>Top logins " << hostName << "<BR></H1><H3></TD>";
                outFile << "<TR><TD ALIGN=center COLSPAN=5 BGCOLOR=#009CBD><B>";
                outFile << "Generated : " <<  asctime( newtime );
                outFile << "</TD><TD ALIGN=center COLSPAN=4 BGCOLOR=#009CBD><B>";
                outFile  << wtmpDate << "</TD>";
		int flag = 0;
		while(flag == 0)
        	{
                	if (temp->next == NULL)
                        	flag = 1;
			if (temp->getlogins() != 0)
			{
		 	 	outFile << "\n<TR><TD BGCOLOR=#808080><FONT COLOR=#FFFFFF><B>" << ++position ;
				outFile << "</FONT></TD>";
				outFile << "\n<TD BGCOLOR=Silver><B>";
                	 	outFile << "<A HREF=http://www.fukt.hk-r.se/~"<< temp->getusername();
                		outFile << ">" << temp->getusername() << "</A> </TD>";
                		outFile << "<TD bgcolor=#FFFEE1><B>" << temp->getfirstname(); 
				outFile << " " << temp->getlastname() << " </TD>"; 
                		outFile << "<TD bgcolor=#D8FDCE><A HREF=http://www.fukt.hk-r.se/cgi-bin/fingeruser.cgi?";
                        	outFile << temp->getusername() << " target=main>";
                        	outFile << "<IMG SRC=image/finger2.gif BORDER=0 >";
                        	outFile << "</A> </TD>";
                        	outFile << "<TD bgcolor=#D8FDCE><A HREF=mailto:";
                        	outFile << temp->getusername() ;
                        	outFile << "@fukt.hk-r.se><IMG SRC=image/mail.gif BORDER=0 >";
                        	outFile << "</A> </TD>";
                        	outFile << "<TD bgcolor=#FFFEE1><B>" << temp->getdaytotal() << " days </TD>";
                        	outFile << "<TD bgcolor=#FFFEE1><B>" << temp->gethours() << " hours \t" << " </TD>";
                        	outFile << "<TD bgcolor=#FFFEE1><B>" << temp->getminutes() << " minutes \t" << "</TD>";
                        	outFile << "<TD bgcolor=#D8FDCE><B>" << temp->getlogins() << " times \t" << "</TD>";
                	}		
			temp = temp->next;
		}
                        outFile << "<TR><TD ALIGN=center VALIGN=top COLSPAN=9 BORDER=1 BGCOLOR=Silver><B>";
                        outFile << "Visitors: <ACCESSED></TD>";

                //outFile << "\n\n</TABLE><BR>";
		//outFile << <B>\"LOGINGS\" C++-program<BR>Coded by ";
                //outFile << "\n<DD><TABLE WIDTH=\"90%\" BORDER=1>";
        outFile << "\n<TR><TD COLSPAN=9 ALIGN=CENTER BGCOLOR=#808080> <B>";
        outFile << "Generated by mlist : ";
        outFile << "<A HREF=ftp://ftp.fukt.hk-r.se/pub/Linux/mlist/>";
        outFile << "ftp://ftp.fukt.hk-r.se/pub/Linux/mlist/</A></B></TD></TR>";
		outFile << "<TR><TD COLSPAN=9 ALIGN=CENTER BGCOLOR=#009CBD><B>Coded by : ";
		outFile << "\n\n<A HREF=http://www.fukt.hk-r.se/~nevcx/>NeVcX (Mats Karlsson)</A>";
		outFile << "</TD></TR></TABLE><HR>";
                //outFile << "This page was generated : " <<  asctime( newtime );
                //outFile << __TIME__ ;
                //outFile  << "<BR>" << wtmpDate;
                outFile << "\n\n<BR>\n</BODY></HTML>";
        }
}

user *sortLogins(user *first)
{
        user *sortedList = NULL;
        user *lastSorted  = sortedList;
        user *beforeBest = first;
        user *temp = first;
        user *loop = first;
        user *best = first;
        int n = 0;

        while(first != NULL)
        {
                loop = first;
                while(loop != NULL)
                {
                        if( best->getdaytotal() < loop->getdaytotal())
                                best = loop;
                        if( best->getdaytotal() == loop->getdaytotal() && best->gethours() < loop->gethours())
                                best = loop;
                        if( best->gethours() == loop->gethours() && best->getdaytotal() == loop->getdaytotal() &&best->getminutes() <= loop->getminutes()) 
                        	best = loop; 
			loop = loop->next;
                }
                temp = first;
                while(temp->next != NULL)
                {
                        if(temp->next == best)
                                beforeBest = temp;
                        temp = temp->next;
                }
                lastSorted = sortedList;
                sortedList = best; //1
                if(best != first && beforeBest != best)
                { 
                        beforeBest->next = best->next; //2
                }
                if(best == first && beforeBest != best)
                {
                        first = first->next;
                }
                if(first == best && beforeBest == best)
                {
                        first = first->next;
                }
                best->next = lastSorted;
                beforeBest = first;
                temp = first;
                loop = first;
                best = first;
                n++;
        }
	first = sortedList;
	sortedList = NULL;
	while(first != NULL)
	{
		temp = first->next;
		first->next = sortedList;
		sortedList = first;
		first = temp;
	}

return sortedList;
}                

//END 
